#!/usr/bin/env python3

import cabinetry
import pyhf
import numpy as np

pyhf.set_backend("numpy", pyhf.optimize.minuit_optimizer(verbose=1))
# jsonpatch SUSY-2018-04_likelihoods/Region-combined/BkgOnly.json SUSY-2018-04_likelihoods/Region-combined/patch.DS_440_80_Staus.json > Staus_440_80.json
# jsonpatch SUSY-2018-04_likelihoods/Region-combined/BkgOnly.json SUSY-2018-04_likelihoods/Region-combined/test.json > BkgOnly.json

jsonf = "BkgOnly.json"
print ( "channels", channels )

ws = cabinetry.workspace.load( jsonf )
channelnames = [ x["name"] for x in ws["channels"] ]
model, data = cabinetry.model_utils.model_and_data(ws)

result, result_obj = pyhf.infer.mle.fit(
            data, model, return_uncertainties=True, return_result_obj=True)

# sample parameters from multivariate Gaussian and evaluate model
sampled_parameters = np.random.multivariate_normal(
    result_obj.minuit.values, result_obj.minuit.covariance, size=10000
)
model_predictions = [
    model.expected_data(p, include_auxdata=False) for p in sampled_parameters
]

yields = np.mean(model_predictions, axis=0)
yield_unc = np.std(model_predictions, axis=0)
print(f"model prediction: {yields} +/- {yield_unc}")

print(f"covariance:\n{np.cov(model_predictions, rowvar=False)}")
print(f"correlation:\n{np.corrcoef(model_predictions, rowvar=False)}")

import IPython
IPython.embed()
